import 'package:flutter/widgets.dart';
import 'package:waterfall_flow/src/widgets/scroll_view.dart';
import 'src/rendering/sliver_waterfall_flow.dart';

class XXSliverWaterFallFlow extends StatefulWidget {
  final Widget Function(BuildContext, int) itemBuilder;
  final void Function(int firstIndex, int lastIndex) onScrollInit;
  final void Function(int firstIndex, int lastIndex) onScrollEnd;
  const XXSliverWaterFallFlow({ Key key,@required this.itemBuilder,this.onScrollInit,this.onScrollEnd}) : super(key: key);

  @override
  _XXSliverWaterFallFlowState createState() => _XXSliverWaterFallFlowState();
}

class _XXSliverWaterFallFlowState extends State<XXSliverWaterFallFlow> {

  bool _isInit = true;
  int _firstIndex;
  int _lastIndex;

  @override
  Widget build(BuildContext context) {
    return NotificationListener<ScrollNotification>(
      onNotification: (ScrollNotification notification) {
        if (notification.runtimeType == ScrollEndNotification) {
          if(widget.onScrollEnd != null){
            widget.onScrollEnd(_firstIndex,_lastIndex);
          }
        }
        return true;
      },
      child:WaterfallFlow.builder(
        gridDelegate:SliverWaterfallFlowDelegateWithFixedCrossAxisCount(
          crossAxisCount: 5,
          crossAxisSpacing: 5.0,
          mainAxisSpacing: 5.0,
          viewportBuilder:(int firstIndex, int lastIndex) {
            _firstIndex = firstIndex;
            _lastIndex = lastIndex;
            if(_isInit && widget.onScrollInit != null){
              widget.onScrollInit(_firstIndex,_lastIndex);
              _isInit = false;
            }
          }
        ),
        itemBuilder:widget.itemBuilder,
      ),
    );
  }
}